#include<bits/stdc++.h>
using namespace std;
int br[1000001];
vector<pair<int, int>> v;
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m=0;
    cin>>n;
    for(int i=0;i<n;i++){
        int a, b;
        cin>>a>>b;
        m=max(m, b);
        v.push_back({a, b});
        for(int j=a;j<b;j++){
            br[j]++;
        }
    }
    int ans=0, index;
    for(int i=0;i<m;i++){
        if(br[i]>=ans){
            index=i;
            ans=br[i];
        }
    }
    cout<<ans<<endl;
    int min_=m+1, max_=0;
    for(int i=0;i<n;i++){
        if(v[i].first<=index && v[i].second>index){
            min_=min(min_, v[i].first);
            max_=max(max_, v[i].second);
        }
    }
    cout<<max_-min_;
    return 0;
}
